<?php
/**
* Plugin allow to insert Goswf player (http://www.gludion.com/go/) into Joomla articles. Joomla 1.5 native.
* @version 1.0
* @package
* @copyright igotoy and various GPL sources
* @license http://www.fsf.org/licensing/licenses/agpl-3.0.html
*/

//You can not directly access the file when you put this code at the beginning:
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

//Now set the registerEvent. The action will start before the content is opened.
$mainframe->registerEvent( 'onPrepareContent', 'plgGludion' );

//The real function starts here
function plgGludion( &$row, &$params, $page=0 )
{
	global $pluginParams;

     //Access the database
     $db =& JFactory::getDBO();
    
     //Check whether the bot should process or not
     if ( JString::strpos( $row->text, 'sgf' ) === false ) {
        return true;
     }

    //Get plugin info
    $plugin =& JPluginHelper::getPlugin('content', 'gludion');
    
    //Search for this tag in the content
    $regex = '/{sgf\s*(.*?)}/i';
    
    //Access the parameters
    $pluginParams = new JParameter( $plugin->params );

    //Check whether plugin has been unpublished
    if ( !$pluginParams->get( 'enabled', 1 ) ) {
        $row->text = preg_replace( $regex, '', $row->text );
        return true;
    }

	// perform the replacement
	$row->text = preg_replace_callback( $regex, 'sgfReplacer', $row->text );

	return true;
}

/**
* Replaces the matched tags
*/
function sgfReplacer( &$matches ) {

	global $pluginParams;
	$code = '';

	if ( $matches[1] )
    {
       $tokens= explode( ",", $matches[1] );
	}
	else
	{
		return $code;
	}
	
	$optionsCount = count( $tokens );
	$sgfFolder = $pluginParams->get( 'sgfFolder', 'images/stories/sgf' );
	$goswfFolder = $pluginParams->get( 'goswfFolder', 'scripts/gludion' );
	$background = $pluginParams->get( 'background', 'FEDFB4' );
	$foreground = $pluginParams->get( 'foreground', 'D86F1E' );
	
	$code .= '<EMBED src="' . $goswfFolder . '/goswf.swf" ';
	$code .= 'flashVars="';
	$code .= 'nav=' . $foreground;
	$code .= '&bg=' . $background;
	$code .= '&url=../../' . $sgfFolder . '/' . $tokens[0];
	if  ( $optionsCount > 1 )
	{
		$code .= '&move=' . $tokens[1];
	}
	$code .= '" bgcolor="#ffffff"
				width="640" height="480"
				type="application/x-shockwave-flash"
				pluginspage="http://www.macromedia.com/go/getflashplayer"></EMBED>';
	
	return $code;
}

?>









